#version 330
#extension GL_ARB_separate_shader_objects : enable





layout(location = 0) in vec2 _vin_Position;
layout(location = 1) in vec2 _vin_TexCoord;
layout(location = 2) in vec4 _vin_Color;

struct SVertexInput
{
	vec2 Position;
	vec2 TexCoord;
	vec4 Color;
	int VertexIndex;
	uint InstanceId;
};

layout(location = 0) smooth out vec2 _vout_fragTexCoord;
layout(location = 1) smooth out vec4 _vout_fragColor;

struct SVertexOutput
{
	vec2 fragTexCoord;
	vec4 fragColor;
	vec4 VertexPosition;
};


layout( std140) uniform UImGui
{
	vec2 Scale;
	vec2 Translate;
} ImGui;


void VertexMain( in SVertexInput  vInput,  out SVertexOutput  vOutput  )
{
	vOutput.fragColor = vInput.Color;
    vOutput.fragTexCoord = vInput.TexCoord;
    vOutput.VertexPosition = vec4(vInput.Position *  ImGui.Scale  +  ImGui.Translate , 0, 1);
}


void main()
{
	SVertexInput vInput;
	SVertexOutput vOutput;

	vInput.Position = _vin_Position;
	vInput.TexCoord = _vin_TexCoord;
	vInput.Color = _vin_Color;
	vInput.VertexIndex = gl_VertexID;
	vInput.InstanceId = uint(gl_InstanceID);
	vOutput.fragTexCoord = vec2(0, 0);
	vOutput.fragColor = vec4(0, 0, 0, 0);
	VertexMain(vInput, vOutput);
	_vout_fragTexCoord = vOutput.fragTexCoord;
	_vout_fragColor = vOutput.fragColor;
	gl_Position = vOutput.VertexPosition;
}
